<?
/*
 * Phormation 
 *  - A library of PHP code to make development of database-driven
 *    html forms easy and quick
 *
 *  Copyright (C) 2000 Jason D. Hildebrand
 *  PeaceWorks Computer Consulting
 *
 *  jason@peaceworks.ca
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Street #330, Boston, MA 02111-1307, USA.
 */


    $full_months = array( 1 => 'January', 
		     2 => 'February', 
		     3 => 'March', 
		     4 => 'April', 
		     5 => 'May', 
		     6 => 'June', 
		     7 => 'July', 
		     8 => 'August', 
		     9 => 'September', 
		     10 => 'October', 
		     11 => 'November', 
		     12 => 'December' );

    $short_months = array( 1 => 'Jan.', 
		     2 => 'Feb.', 
		     3 => 'Mar.', 
		     4 => 'Apr.', 
		     5 => 'May', 
		     6 => 'June', 
		     7 => 'July', 
		     8 => 'Aug.', 
		     9 => 'Sept.', 
		     10 => 'Oct.', 
		     11 => 'Nov.', 
		     12 => 'Dec.' );

    // parses a PostgreSQL date in format YYYY/MM/DD or YYYY-MM-DD 
    // into month, day, year components
    function parse_date( $date ) {
	$array["year"] = strtok( $date, "/-" );
	$array["month"] = strtok( "/-" );
	$array["day"] = strtok( "/-" );
	return $array;
    }

    // outputs a month/day combo
    function output_single_date( $date ) {
	global $short_months;
	$pdate = parse_date( $date );
	echo $short_months[ (int) $pdate["month"] ] . " " . $pdate["day"];
    }

    // outputs a month/day range which makes sense to humans 
    function output_date_range( $startdate, $enddate ) {
	global $short_months;
	$pstartdate = parse_date( $startdate );
	$penddate = parse_date( $enddate );

	if( ((int)$pstartdate["month"]) == ((int)$penddate["month"]) ) {
	    echo $short_months[ (int)$pstartdate["month"] ] . " " . $pstartdate["day"] . "-" . $penddate["day"];
	} else {
	    echo $short_months[ (int)$pstartdate["month"] ] . " " . $pstartdate["day"] . " - ";
	    echo $short_months[ (int)$penddate["month"] ] . " " . $penddate["day"];
	}
    }

?>
