<?
/*
 * Phormation 
 *  - A library of PHP code to make development of database-driven
 *    html forms easy and quick
 *
 *  Copyright (C) 2000 Jason D. Hildebrand
 *  PeaceWorks Computer Consulting
 *
 *  jason@peaceworks.ca
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Street #330, Boston, MA 02111-1307, USA.
 */

include_once( PHORMATIONDIR."/misc_fcns.php" );
// these variables will be preserved, as long as makephself is used to
// construct the URLs
$sessionvars[] = "pagenum";
$sessionvars[] = "sort";
$sessionvars[] = "sort_dir";
$sessionvars[] = "action";
$sessionvars[] = "record_id";
$sessionvars[] = "catList";
$sessionvars[] = "statusList";
$sessionvars[] = "nameList";
$sessionvars[] = "entry_id";
$sessionvars[] = "desPosCode";
$sessionvars[] = "desCntry";
$sessionvars[] = "desLang";


// this function constructs a URL for the display table page, and
// automatically adds the variables listed above, so that they are preserved.
function makephpself( $params ) {
    global $PHP_SELF; 
    global $sessionvars;

    //echo $params . "<BR>";

    for( $i = 0; !empty( $sessionvars[$i] ); $i++ ) {
	$varname = $sessionvars[$i];
	global $$varname;
    }

    $pairs = split( "&", $params );
    for( $i = 0; !empty( $pairs[$i] ); $i++ ) {
	$varname = strtok( $pairs[$i], "=" );
	$value = strtok( "=" );
	//echo "Var = $varname, Value = $value <BR>";
	$vars[$varname] = $value;
    }

    $url = $PHP_SELF . "?";
    for( $i = 0; !empty( $sessionvars[$i] ); $i++ ) {
	$varname = $sessionvars[$i];
	if( $vars[ $varname ] != "" ) {
	    $url .= $varname . '=' . $vars[ $varname ] . '&';
	} else if( $$varname != "" ) {
	    $url .= $varname . '=' . $$varname . '&';
	}
    }
    return( $url );
}

function displayresult( $result, $fields, $names, $params )
{
    global $INDEXCOLOUR1, $INDEXCOLOUR2, $TABLEHEADERCOLOUR, $pagenum, $sort_dir;
    global $conn;

    $editfield = $params["editfield"];
    $key = $params["key"];
    $title = $params["title"];
    $editlink = $params["editlink"];
    $pagelength = $params["pagelength"];
    $extraLink = $params["extraLink"];
    $deleteLink = $params["deleteLink"];

    $colour[0] = empty( $INDEXCOLOUR1 ) ? "#e6e6e6" : $INDEXCOLOUR1;
    $colour[1] = empty( $INDEXCOLOUR2 ) ? "#d0d0d0" : $INDEXCOLOUR2;
    $tableheadercol = empty( $TABLEHEADERCOLOUR ) ? "#a0a0e0" : $TABLEHEADERCOLOUR;
    $numrows = $result->numRows();
    if( $numrows == 0 ) {
#	echo "There are <B>no records</B> in the database. Click <B>Create New Record</B> to add records.<P>";
      echo "No records found. <P>\n";
	return;
    }

    if( empty( $pagenum ) ) {
	$pagenum = 0;
    }
    if( empty( $pagelength ) ) {
	$pagelength = 200;
    }

    $startrecord = $pagelength * $pagenum;
    $endrecord = min( $pagelength * ( $pagenum + 1 ) - 1, $numrows - 1 );
    $numpages = ceil( $numrows / $pagelength );
    $navline = '';

    if( $pagenum > 0 ) {
	$navline .= '<a href="' . makephpself( "pagenum=" . ($pagenum - 1) ) .  '">Previous Page</A> - ';
    } else {
      //	echo 'Previous Page - ';
    }
    if ($numrows > 10) {
      $navline .= 'Viewing records ' . ( $startrecord + 1 ) . ' to  ' . ( $endrecord + 1 ) ; 
      $navline .= ' of ' . $numrows . ' (Page ' . ( $pagenum + 1 ) . ' of ' . $numpages . ')';
    }
    if( $pagenum < $numpages - 1 ) {
	$navline .= ' - <a href="' . makephpself( "pagenum=" . ($pagenum + 1) ) .  '">Next Page</A>';
    } else {
      //	echo ' - Next Page';
    }
    $navline .= '<P>'."\n";
    print $navline;
    if ($sort_dir == "ASC") $sort_dir= "DESC";
    else $sort_dir = "ASC";


    echo '<TABLE BORDER=0 CELLSPACING=1 CELLPADDING=3 BGCOLOR="' . $tableheadercol .'" FGCOLOR="#FFFFFF">'."\n";
    echo '<TH bgcolor="#ffffff">&nbsp;</TH>';
    if ($deleteLink) {echo '<TH bgcolor="#ffffff">&nbsp;</TH>';}
    if ($extraLink) {
      foreach ($extraLink as $ind => $val) {
	echo '<TH bgcolor="#ffffff">&nbsp;</TH>'."\n";
      }
    }
    for( $i = 0; ! empty( $names[$i] ); $i += 1 ) {
      echo '<TH bgcolor=' . $tableheadercol . '><A HREF="' . makephpself( "pagenum=0&sort=" . $fields[$i] . "&sort_dir=" . $sort_dir ) . '">' . $names[$i] . '</A></TH>';
    }
    echo "</TR>";
    $row = 0;
    for( $i = $startrecord; $i <= $endrecord; $i += 1 ) {
      //      $conn->row[$result->result] = $i;
      $array = $result->fetchRow(DB_FETCHMODE_ASSOC,$i);
      echo "<TR BGCOLOR=" . $colour[ $i % 2 ] . ">";
	
	
      if ($deleteLink == "default") {
	  echo '<TD bgcolor="#ffffff">';
	  echo '<a href="' . makephpself( "action=delete&record_id=" . $array[$key] ) . '" onClick="return confirmdelete()">';
	  echo '<img src="' . PHORMATIONIMAGEDIR . '/delete.gif" alt="delete record" border="0"></a></TD>';
	} elseif ($deleteLink) {
	  echo '<TD bgcolor="#ffffff">';
	  echo '<a href="' . add_var_to_url($deleteLink["link"],'record_id='. $array[$key] ) . '" onClick="return confirmdelete()">';
	  echo '<img src="' . PHORMATIONIMAGEDIR . '/'.$deleteLink["icon"].'" alt="'.$deleteLink["alt"].'" border="0"></a></TD>';
	}
	
	echo '<TD bgcolor="#ffffff"><a href="' . add_var_to_url($editlink,'record_id='.$array[$key]) . '">';
	echo '<img src="' . PHORMATIONIMAGEDIR . '/edit.gif" alt="edit record" border="0"></a></TD>';
	if ($extraLink) {
	  foreach ($extraLink as $ind => $val) {
	    echo '<TD bgcolor="#ffffff"><a href="' . add_var_to_url($extraLink[$ind]["link"],'record_id='.$array[$key]) . '">';
#	    echo $extraLink[$key]["alt"].'</a></TD>';
	    echo '<img src="' . PHORMATIONIMAGEDIR . '/'.$extraLink[$ind]["icon"].'" alt="'.$extraLink[$ind]["alt"].'" border="0"></a></TD>';
	  }
	}

	for( $j = 0; ! empty( $fields[$j] ); $j += 1 ) {
	    echo "<TD>\n";
	    if( empty( $array[ $fields[$j]] ) ) {
		echo "&nbsp;";
	    } else {
                if( !empty( $params[$fields[$j]]["format"] ) ) {
                    $format_function = "format_" . $params[$fields[$j]]["format"];
                    if( function_exists($format_function) ){
                        $formatted_data = $format_function( $array[$fields[$j]] );
                    } else {
                        $formatted_data = $array[$fields[$j]];
                    }
                } else {
                    $formatted_data = $array[$fields[$j]];
                }

		echo nl2br($formatted_data);
	    }
	    echo "</TD>\n";
	}
	echo "</TR>\n";
    }
    echo "</TABLE>\n";
    print $navline;
}


function table_index( $fields, $names, $params )
{
    global $conn, $sort, $action, $record_id, $sort_dir;

    // get params
    $title = $params["title"];

    if( $action == "delete" ) {
	// if a record should be deleted
	if( !empty( $params["predelete_hook"] ) ) {
	    // call the hook function if it exists,
	    $params["predelete_hook"]( $record_id );
	}
	$query = $params["delquery"] . $record_id;
	$result = $conn->query($query);
	if (DB::isError($result)) {
	  echo "Error: $query <br>";
	  die($result->getMessage());
	} 
	// else echo "success : $query<BR>";
	header( "Location: " . makephpself( 'action=nothing' ) );
	return;
    }

    
echo "        
        <HTML>
        <HEAD>
";
 if( function_exists( 'printHeaders' ) ) {
      printHeaders();
 }

echo "
       </HEAD>
";

	if( function_exists( 'html_before_table' ) ) {
	    html_before_table();
	}
?>
    <script>
	function confirmdelete() {
	    $result = confirm( "Do you really want to delete this record?" );
	    if( $result ) {
		document.location.replace( "<? echo makephpself( 'action=delete&record_id=' . $record_id ) ?>" );
	    } else {
		return false;
	    }
	}
    </script>
    <h1><? echo $title ?></h1>
    <?	
	//	if( function_exists( html_before_table ) ) {
	//	    html_before_table();
	//	}
	if( ! empty( $params["maindesc"] ) ) {
	    echo '<a href="' . $params["mainlink"] . '">' . $params["maindesc"] . '</A> - ';
	}
	if( ! empty( $params["backdesc"] ) ) {
	    echo '<a href="' . $params["backlink"] . '">' . $params["backdesc"] . '</A> - ';
	}
	if( ! empty( $params["searchdesc"] ) ) {
	    echo '<a href="' . $params["searchlink"] . '">' . $params["searchdesc"] . '</A> - ';
	}
	if( ! empty( $params["newlink"] ) ) {
	  echo '<a href="' . $params["newlink"] . '">'.$params["newlinktext"].'</A>';
	}
	if( !empty( $params["addmultiplelink"] ) ) {
	    echo ' - <a href="' . $params["addmultiplelink"] . '">'.$params["addmultiplelink"].'</A>';
	}
	echo "<P>";
	echo $params["instr"];


    if ($params["whereclause"]) {
      $whereclause = " WHERE (";
      foreach($params["whereclause"] as $key => $val){
	$whereclause .= $val. " AND ";
      }
      $whereclause = substr($whereclause,0,-5).") ";
    }    
    $query = $params["query"] . $whereclause;

    if( $sort == "" ) {
	$sortfield = $params["defaultsort"];
    } else {
	$sortfield = $sort;
    }


    $query .= " order by $sortfield ".$sort_dir;
    $result = $conn->query($query);
    if (DB::isError($result)) {
      echo "Error: $query <br>";
      echo $result->getMessage()."<BR>";
      return 0;
    }
    //    echo "type of result in displaytable = ".gettype($result)." numrows = ". $result->numRows()."<br>";

    displayresult( $result, $fields, $names, $params );
    ?>
    </BODY>
    </HTML>
    <?
}
?>
