<?
/*
 * Phormation 
 *  - A library of PHP code to make development of database-driven
 *    html forms easy and quick
 *
 *  Copyright (C) 2000 Jason D. Hildebrand
 *  PeaceWorks Computer Consulting
 *
 *  jason@peaceworks.ca
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Street #330, Boston, MA 02111-1307, USA.
 */


include_once( PHORMATIONDIR."/widgets.php" );
include_once( PHORMATIONDIR."/sql_fcns.php" );
//include( "include/debug.php" );

function set_varprefix( $datatypes, $prefix ) {
  for( $i = 0; ! empty( $datatypes[$i] ); $i++ ) {
    $newtypes[$i] = $datatypes[$i] . "&varprefix=" . $prefix;
  }
  return( $newtypes );
}

function make_values_bumpy( $fields, $values ) 
{
  // fields is a array where each element is a field, or a
  // comma-separated list of fields values must be an
  // associative array, such as that which is returned by
  // mysql_fetch_array or pg_fetch_array
  
  //dump_array( "values", $values );
  
  for( $i = 0; ! empty( $fields[$i] ); $i++ ) {
    if( ! strchr( $fields[$i], "," ) ) {
      // do the next element
      $newvalues[$i] = $values[$fields[$i]];
      continue;
    }
    $array = array();
    $f = strtok( $fields[$i], "," );
    while( $f ) {
      $array[$f] = $values[$f];
      $f = strtok( "," );
    }
    $newvalues[$i] = $array;
  }
  $values = $newvalues;
  //dump_array( "values", $values );
}

function createform( $fields, $names, $datatypes, $values, 
		     $record_id, $errors, $url, $opts )
{
  global $FORMBGCOLOUR, $PHP_SELF, $key;
  
  //$numfields = count( $fields );
  
  // create some javascript stuff we need, and an HTML form
    ?>
    <script language="JavaScript">
       <!--
       function confirmdelete() {
      $result = confirm( "Do you really want to delete this record?" );
      if( $result ) {
	document.location.replace( "<? echo $url["ondelete"] . '&record_id=' . $record_id ?>" );
      }
    }
  // -->
  </script>
      
      <?
      if( ! $opts["custom_table"] ) {
	echo '<table border="0" cellspacing="1" cellpadding="0" bgcolor="'. $FORMBGCOLOUR . '">';
      }
    ?>
      
      <tr><td>
	 <form name="mainform"
	 action="<? echo add_var_to_url( $url["onsubmit"], "record_id=$record_id") ?>" method="post" >
	 </td></tr>
    <?
  
  // seeif there were any error generated. Make a warning if there were>  
  for ($g=0;$g<sizeof($errors);$g++){
    $errorlen += strlen($errors[$g]);
  }
  if ($errorlen > 0) echo "<h2>Error: Record not created.</h2>"; 

	 // now create a input field for each DB field
	 for( $i = 0; !empty( $fields[ $i ] ); $i++ ) {
	   
	   $type = "";
	   parse_str( $datatypes[ $i ] );
	   
	   // the functions to create widgets are named maketext, makedate,
	   // etc.
	   $func = "make_" . $type . "_widget";
	   
	   // call the function to create the widget
	   
	   //echo "\n\n<BR>Pretty Name:" . $names[$i] . "<BR>\n";
	   //echo "Value: " . $values[$i] . "<BR>\n";
	   //echo "Field: " . $fields[$i] . "<BR>\n";
	   //echo "Datatype: " . $datatypes[$i] . "<BR>\n";
	   
	   $func( $names[$i], $values[$i], $fields[$i], $errors[$i], $datatypes[$i] );
	 }
  
  // finish the form
    ?>
	 <tr>
	    <td colspan="3" align="center">
	    <input type = "hidden" name="refresh" value ="" >
	    <?
	    echo '<input type = "submit" name="ph_action" value = "' . $opts["submittext"] . '" >';
	if( empty( $opts["nocancel"] ) ) {
	    echo '<input type = "submit" name="ph_action" value = "' . $opts["canceltext"] . '" >';
	}
	if( empty( $opts["nodelete"] ) ) {
	    echo '<input type = "button" name="ph_action" value = "' . $opts["deletetext"] . '" onClick="confirmdelete()" >';
	}
        echo '</form></td></tr>';
	if( ! $opts["custom_table"] ) {
	    echo '</table>';
	}
    }

function loaddefaults( $datatypes )
{
  $values = array();
  for( $i = 0; ! empty( $datatypes[ $i ] ); $i++ ) {
    $default = "";
    parse_str( $datatypes[$i] );
    $values[$i]=$default;
  }
  return $values;
}

function validatechanges( $fields, $names, $datatypes, $values, $sql, $errors )
{
  $allsuccess = true;
  $numfields = count( $fields );
  for( $i = 0; $i < $numfields; $i += 1 ) {
    
    $type = "";
    parse_str( $datatypes[ $i ] );

    // the functions to validate the widgets are named validatetext, validatedate,
    // etc.
    $func = "validate_" . $type . "_widget";
    
    // call the function to create the widget
    $errortext = "";
    $value = "";
    $success = $func( $names[$i], &$value, $fields[$i], $datatypes[$i], &$sql, &$errortext );
    $allsuccess = $allsuccess & $success;
    
    if( ! empty( $errortext ) ) {
      $errortext = "<B>" . $errortext . "</B>";
    }
    
    // store any error text for this widget
    $errors[$i] = $errortext;	
    $values[$i] = $value;
    
  }
  return $allsuccess;
}

function call_widget_method( $method, $fields, $names, $datatypes, $values, $tablename, $tablekey, $record_id, $sql )
{
  $numfields = count( $fields );
  for( $i = 0; $i < $numfields; $i += 1 ) {
    
    $type = "";
    parse_str( $datatypes[ $i ] );
    
    $func = $method . "_" . $type . "_widget";
    
    if( function_exists( $func ) ) {
      // call the widget method 
      $success = $func( $names[$i], &$values[$i], $fields[$i], $datatypes[$i], $record_id );
    }
  }
  
}

function commitchanges( $fields, $names, $datatypes, $values, $tablename, $tablekey, $record_id, $sql, $opts )
{
  // if there is a precommit hook, we call it now
  if( ! empty( $opts["precommit_hook"] ) ) {
    $result = $opts["precommit_hook"]( $fields, $names, $datatypes, &$values, $tablename, $tablekey, $record_id, &$sql );
    if( ! $result ) {
      // if we get false, don't commit
      return;
    }
  }
  
  // if there is a commit function supplied, we call it
  if( !empty( $opts["commit_hook"] ) ) {
    $opts["commit_hook"]( $tablename, $tablekey, &$record_id, $sql );
  } else {
    // otherwise make changes to database 
    savechanges( $tablename, $tablekey, &$record_id, $sql );
  }
  
  // call commit on widgets which need it, using the new record_id obtained
  call_widget_method( "commit", $fields, $names, $datatypes, &$values, $tablename, $tablekey, $record_id, $sql );
  
  if( ! empty( $opts["postcommit_hook"] ) ) {
    $opts["postcommit_hook"]( $fields, $names, $datatypes, &$values, 
			      $tablename, $tablekey, $record_id, &$sql );
  }
}

function abortchanges( $fields, $names, $datatypes, $values, 
		       $tablename, $tablekey, $record_id, $sql )
{
  $numfields = count( $fields );
  for( $i = 0; $i < $numfields; $i += 1 ) {
    
    $type = "";
    parse_str( $datatypes[ $i ] );
    
    // the functions to validate the widgets are named validatetext, validatedate,
    // etc.
    $func = "abort_" . $type . "_widget";
    
    if( function_exists( $func ) ) {
      // call the function to commit the widget's changes
      $success = $func( $names[$i], $values[$i], $fields[$i], $datatypes[$i], $record_id );
    }
  }
}

function defaults( $url, $opts )
{
  global $PHP_SELF;
  
  if( empty( $opts["submittext"] ) ) {
    $opts["submittext"] = "Save Changes";
  }
  if( empty( $opts["canceltext"] ) ) {
    $opts["canceltext"] = "Cancel Changes";
  }
  if( empty( $opts["deletetext"] ) ) {
    $opts["deletetext"] = "Delete Record";
  }
  
  if( empty( $url["onsubmit"] ) ) {
    $url["onsubmit"] = $PHP_SELF;
  }
  if( empty( $url["ondelete"] ) ) {
    $url["ondelete"] = $PHP_SELF . "?ph_action=delete";
  }
  if( empty( $url["aftersubmit"] ) ) {
    $url["aftersubmit"] = $url["home"];
  }
  if( empty( $url["aftercancel"] ) ) {
    $url["aftercancel"] = $url["home"];
  }
  if( empty( $url["afterdelete"] ) ) {
    $url["afterdelete"] = $url["home"];
  }
}

function form_main( $tablename, $tablekey, $fields, $names, $datatypes, $record_id, $url, $opts )
{
  global $ph_action, $refresh, $redraw, $BODYTAGS;
  
  defaults( &$url, &$opts );
  $datatypes = set_varprefix( $datatypes, "w_" );
  
  // check if the refresh variable is set.  If so, we'll refresh
  // the form.  If it is set to "refresh", then refresh the form
  // If it is set to anything else, redraw w/o error messages
  if( ! empty( $refresh ) ) {
    $ph_action = $refresh;
    $refresh = "";
    $redraw = "";
    if( $opts["calltwice"] ) {
      return;
    }
  }
  if( ! empty( $redraw ) ) {
    $ph_action = "redraw";  
    $redraw = "";
    if( $opts["calltwice"] ) {
      return;
    }
  }
  
  if( $ph_action == "validate" || $ph_action == $opts["submittext"] ) {
    
    if (DEBUG) {
      echo "<hr>";
      while (list($key, $val) = each($GLOBALS))
	echo "$key: $val<BR>\n";
      reset($GLOBALS);
    }
    $result = validatechanges( $fields, $names, $datatypes, &$values, 
			       &$sql, &$errors );
    if( $result ) {
      // if everything was ok, save the data
      commitchanges( $fields, $names, $datatypes, &$values, $tablename, $tablekey, $record_id, &$sql, $opts );
      
      //now jump to somewhere else
      header( "Location: " . $url["aftersubmit"] );
      $ph_action = "do_nothing";
      return;
    } else {
      // we need to refresh the form
      $ph_action = "refresh";
      global $ph_values, $ph_errors;
      $ph_values = $values;
      $ph_errors = $errors;
      if( $opts["calltwice"] ) {
	return;
      }
    }
  }
  
  if( $ph_action == "" ) {
    
    // if there is a record id, fetch existing data
    if( $record_id != "" ) {
      if( !empty( $opts["fetch_hook"] ) ) {
	$values = $opts["fetch_hook"]( $tablename, $tablekey, 
				       $fields, $record_id );
	if( $values) {
	  make_values_bumpy( $fields, &$values); 
	} else {
	  if( $opts["abort_on_fetch_error"] ) {
	    $opts["error_hook"]();
	    return;
	  } else {
	    $values = loaddefaults( $datatypes );
	  }
	}
      } else {
	$result = fetchrecord( $tablename, $tablekey, $fields, $record_id );
	if( $result ) {
	  $values = $result->fetchRow(DB_FETCHMODE_ASSOC);
	  make_values_bumpy( $fields, &$values); 
	} else {
	  if( $opts["abort_on_fetch_error"] ) {
	    $opts["error_hook"]();
	    return;
	  } else {
	    $values = loaddefaults( $datatypes );
	  }
	}
      }
    } else {
      // if there is no record_id then this is a new record; create an empty form
      $values = loaddefaults( $datatypes );
    }
    
    
    // at this point the values are loaded, either from the hook, from
    // the database, or from default values
    // and we've massaged the result (using make_values_bumpy) so that for multi-field
    // widgets, all values are in a subarray (not simply a flat array)
    call_widget_method( "setup", $fields, $names, $datatypes, &$values, $tablename, $tablekey, $record_id, $sql );
    if( function_exists( "html_before_form" ) ) {
      html_before_form();
    }
    createform( $fields, $names, $datatypes, $values, $record_id, $errors, $url, $opts );
    if( function_exists( "html_after_form" ) ) {
      html_after_form();
    }
  }
  
  if( $ph_action == "refresh" || $ph_action == "redraw" ) {
    global $ph_values;
    global $ph_errors;
    if( isset( $ph_values ) ) {
      $values = $ph_values;
      $errors = $ph_errors;
    } else {
      $result = validatechanges( $fields, $names, $datatypes, &$values, &$sql, &$errors );
    }
    if( function_exists( "html_before_form" ) ) {
      html_before_form();
    }
    if( $ph_action == "redraw" ) {
      // for redrawing we don't want to display errors, so clear the array
      $errors = array();
    }
    createform( $fields, $names, $datatypes, $values, $record_id, $errors, $url, $opts );
    if( function_exists( "html_after_form" ) ) {
      html_after_form();
    }
  }
  
  if( $ph_action == "cancel" || $ph_action == $opts["canceltext"] ) {
    abortchanges( $fields, $names, $datatypes, &$values, $tablename, $tablekey, $record_id, $sql );
    header( "Location: " . $url["aftercancel"] );
    return;
  }
  
  if( $ph_action == "delete" || $ph_action == $opts["deletetext"] ) {
    // we assume that the delete has been confirmed by this point
    abortchanges( $fields, $names, $datatypes, &$values, $tablename, $tablekey, $record_id, $sql );
    if( !empty( $opts["delete_hook"] ) ) {
      $opts["delete_hook"]( $tablename, $tablekey, $record_id );
    } else {
      deleterecord( $tablename, $tablekey, $record_id );
    }
    header( "Location: " . $url["afterdelete"] );
  } 
  if (DEBUG) {echo "ph_action = \"$ph_action\"<BR>"; }
}

function phorm_parse_args( $tablename, $tablekey, $fields, $names, $datatypes, $record_id, $url, $opts )
{
  global $ph_action, $refresh, $redraw, $BODYTAGS;

  defaults( &$url, &$opts );
  $datatypes = set_varprefix( $datatypes, "w_" );
  
  // check if the refresh variable is set.  If so, we'll refresh
  // the form.  If it is set to "refresh", then refresh the form
  // If it is set to anything else, redraw w/o error messages
  if( ! empty( $refresh ) ) {
    $ph_action = $refresh;
    $refresh = "";
    $redraw = "";
    if( $opts["calltwice"] ) {
      return;
    }
  }
  if( ! empty( $redraw ) ) {
    $ph_action = "redraw";  
    $redraw = "";
    if( $opts["calltwice"] ) {
      return;
    }
  }
  
  if( $ph_action == "validate" || $ph_action == $opts["submittext"] ) {
    $result = validatechanges( $fields, $names, $datatypes, &$values, &$sql, &$errors );
    if( $result ) {
      // if everything was ok, save the data
      commitchanges( $fields, $names, $datatypes, &$values, $tablename, $tablekey, $record_id, &$sql, $opts );
      
      // now jump to somewhere else
      header( "Location: " . $url["aftersubmit"] );
      $ph_action = "do_nothing";
      return;
    } else {
      // we need to refresh the form
      $ph_action = "refresh";
      global $ph_values, $ph_errors;
      $ph_values = $values;
      $ph_errors = $errors;
      if( $opts["calltwice"] ) {
	return;
      }
    }
  }
  
  if( $ph_action == "" ) {
    
    // if there is a record id, fetch existing data
    if( $record_id != "" ) {
      if( !empty( $opts["fetch_hook"] ) ) {
	$values = $opts["fetch_hook"]( $tablename, $tablekey, $fields, $record_id );
	if( $values) {
	  make_values_bumpy( $fields, &$values); 
	} else {
	  if( $opts["abort_on_fetch_error"] ) {
	    $opts["error_hook"]();
	    return;
	  } else {
	    $values = loaddefaults( $datatypes );
	  }
	}
      } else {
	$result = fetchrecord( $tablename, $tablekey, $fields, $record_id );
	if( $result ) {
	  $values = $result->fetchRow(DB_FETCHMODE_ASSOC);
	  make_values_bumpy( $fields, &$values); 
	} else {
	  if( $opts["abort_on_fetch_error"] ) {
	    $opts["error_hook"]();
	    return;
	  } else {
	    $values = loaddefaults( $datatypes );
	  }
	}
      }
    } else 
  // if there is no record_id then this is a new record; create an empty form
      $values = loaddefaults( $datatypes );
  }
}

?>
