<?
/*
 * Phormation 
 *  - A library of PHP code to make development of database-driven
 *    html forms easy and quick
 *
 *  Copyright (C) 2000 Jason D. Hildebrand
 *  PeaceWorks Computer Consulting
 *
 *  jason@peaceworks.ca
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Street #330, Boston, MA 02111-1307, USA.
 */

    function validate_all_changes( $fields, $names, $datatypes, $values, $sql, $errors, $numforms )
    {
	$result = true;
	$errors = array();
	$values = array();
	for( $i=0; $i < $numforms; $i++ ) {
	    $result = $result & validatechanges( $fields, $names, set_varprefix( $datatypes, "ph_$i" ),
					         &$values[$i], &$sql[$i], &$errors[$i] );
	}
	return $result;
    }

    function commit_all_changes( $fields, $names, $datatypes, $values, $tablename, $tablekey, $record_id, $sql, $opts, $numforms )
    {
	for( $i=0; $i < $numforms; $i++ ) {
	    commitchanges( $fields, $names, set_varprefix( $datatypes, "ph_$i" ), 
			   &$values[$i], $tablename, $tablekey, $record_id, &$sql[$i], $opts );
	}
    }


    function create_all_forms( $fields, $names, $datatypes, $values, $record_id, $errors, $url, $opts, $numforms )
    {
	global $FORMBGCOLOUR, $PHP_SELF, $key;

	//$numfields = count( $fields );

	// create some javascript stuff we need, and an HTML form
	?>
	<form name="mainform" enctype="multipart/form-data" 
	    action="<? echo add_var_to_url( $url["onsubmit"], "record_id=$record_id") ?>" method="post" >
	<?
	echo '<table border="0" cellspacing="1" cellpadding="0" bgcolor="'. $FORMBGCOLOUR . '">';

	echo '<tr><TD></td><td>' . $opts["numforms_prompt"] . '<select name="numforms" onChange="mainform.refresh.value=\'redraw\'; mainform.submit()">';
	for( $i = 1; $i <= $opts["maxforms"]; $i++ ) {
	    if( $i == $numforms ) {
		echo '<option selected value="' . $i . '">' . $i . '</option>';
	    } else {
		echo '<option value="' . $i . '">' . $i . '</option>';
	    }
	}
	echo '</select><input type="submit" name="ph_action" value="Update form"></td></tr>';

	// now create a input field for each DB field
	for( $j = 0; $j < $numforms; $j++ ) {
	    echo '<tr><td><BR><BR><B><font size="+2">' . $opts["item_heading"] . ' #' . ($j+1) . ':</font></B></td></tr>';	
	    $newdatatypes = set_varprefix( $datatypes, "ph_$j" );
	    for( $i = 0; !empty( $fields[ $i ] ); $i++ ) {

		$type = "";
		parse_str( $newdatatypes[ $i ] );

		// the functions to create widgets are named maketext, makedate,
		// etc.
		$func = "make_" . $type . "_widget";

		// call the function to create the widget

		//echo "\n\n<BR>Pretty Name:" . $names[$i] . "<BR>\n";
		//echo "Value: " . $values[$j][$i] . "<BR>\n";
		//echo "Field: " . $fields[$i] . "<BR>\n";
		//echo "Datatype: " . $datatypes[$i] . "<BR>\n";

		$func( $names[$i], $values[$j][$i], $fields[$i], $errors[$j][$i], $newdatatypes[$i] );
	    }
	}

	// finish the form
	?>
	</table>
	<input type = "hidden" name="refresh" value ="" >
	<?
	echo '<input type = "submit" name="ph_action" value = "' . $opts["submittext"] . '" >';
	if( empty( $opts["nocancel"] ) ) {
	    echo '<input type = "submit" name="ph_action" value = "' . $opts["canceltext"] . '" >';
	}
        echo '</form>';
    }

    function abort_all_changes( $fields, $names, $datatypes, $values, $tablename, 
				$tablekey, $record_id, $sql, $numforms )

    {
	for( $i=0; $i < $numforms; $i++ ) {
	    abortchanges( $fields, $names, set_varprefix( $datatypes, "ph_$i" ), 
			  &$values[$i], $tablename, $tablekey, $record_id, $sql[$i] );
	}
    }


    function load_all_defaults( $datatypes, $numforms )
    {
	$values = array();
	for( $i=0; $i < $numforms; $i++ ) {
	    $values[$i] = loaddefaults( $datatypes );
	}
	return $values;
    }

    function multiform_main( $tablename, $tablekey, $fields, $names, $datatypes, $record_id, $url, $opts, $numforms )
    {
	global $ph_action, $refresh, $BODYTAGS;


	defaults( &$url, &$opts );

	if( ! empty( $refresh ) ) {
	    $ph_action = $refresh;  // this is probably refresh or redraw
	    $refresh = "";
	    if( $opts["calltwice"] ) {
		return;
	    }
	}
	if( $ph_action == "Update form" ) {
	    $ph_action = "redraw";
	    if( $opts["calltwice"] ) {
		return;
	    }
	}

	if( $ph_action == "validate" || $ph_action == $opts["submittext"] ) {
	    $errors = array();
	    $result = validate_all_changes( $fields, $names, $datatypes, &$values, &$sql, &$errors, $numforms );
	    if( $result ) {
		// if everything was ok, save the data
		commit_all_changes( $fields, $names, $datatypes, &$values, $tablename, $tablekey, $record_id, &$sql, $opts, $numforms );

		// now jump to somewhere else
		header( "Location: " . $url["aftersubmit"] );
		$ph_action = "do_nothing";
		return;
	    } else {
		// we need to refresh the form
		$ph_action = "refresh";
		global $ph_values, $ph_errors;
		$ph_values = $values;
		$ph_errors = $errors;
		if( $opts["calltwice"] ) {
		    return;
		}
	    }
	}


	if( $ph_action == "" ) {
	    if( function_exists( "html_before_form" ) ) {
		html_before_form();
	    }
	    $values = load_all_defaults( $datatypes, $numforms );
	    create_all_forms( $fields, $names, $datatypes, $values, $record_id, $errors, $url, $opts, $numforms );
	    if( function_exists( "html_after_form" ) ) {
		html_after_form();
	    }
	}


	if( $ph_action == "refresh" || $ph_action == "redraw" ) {
	    global $ph_values;
	    global $ph_errors;
	    if( isset( $ph_values ) ) {
		$values = $ph_values;
		$errors = $ph_errors;
	    } else {
		$result = validate_all_changes( $fields, $names, $datatypes, &$values, &$sql, &$errors, $numforms );
	    }
	    if( function_exists( "html_before_form" ) ) {
		html_before_form();
	    }
	    if( $ph_action == "redraw" ) {
		// for redrawing we don't want to display errors, so clear the array
		$errors = array();
	    }
	    create_all_forms( $fields, $names, $datatypes, $values, $record_id, $errors, $url, $opts, $numforms );
	    if( function_exists( "html_after_form" ) ) {
		html_after_form();
	    }
	}

	if( $ph_action == "cancel" || $ph_action == $opts["canceltext"] ) {
	    abort_all_changes( $fields, $names, $datatypes, &$values, $tablename, $tablekey, $record_id, $sql, $numforms );
	    header( "Location: " . $url["aftercancel"] );
	    return;
	}
    }
?>
