<?
/*
 * Phormation 
 *  - A library of PHP code to make development of database-driven
 *    html forms easy and quick
 *
 *  Copyright (C) 2000 Jason D. Hildebrand
 *  PeaceWorks Computer Consulting
 *
 *  jason@peaceworks.ca
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Street #330, Boston, MA 02111-1307, USA.
 */


    include_once( "$phormationdir/dbi.php" );

    function quote_if_string( $value )
    {
	if( is_string( $value ) ) {
	    $value = "'" . $value . "'";
	}
	return $value;
    }

    function fetchrecord( $tablename, $tablekey, $fields, $record_id ) {
	global $conn;

	$query = "select ";
	for( $i = 0; $i < count( $fields ) - 1; $i++ ) {
	  $query .= $fields[$i] . ", ";
	}
	$query .= $fields[$i] . " from $tablename where $tablekey = ";
	$query .= quote_if_string( $record_id );
	//echo $query . '<BR>';
	$result = dbi_exec( $conn, $query );
	return( $result );
    }

    function deleterecord( $tablename, $tablekey, $record_id ) {
	global $conn;

	$query = "delete from \"$tablename\" where \"$tablekey\" = $record_id";
	$result = dbi_exec( $conn, $query );
	return( $result );
    }

    function insertvalue( $fieldname, $value, $sql )
    {
	$sql[0][] = $fieldname;
	$sql[1][] = $value;
    }

    function savechanges( $tablename, $tablekey, $record_id, $sql )
    {
	global $conn;

	//for( $i = 0; ! empty( $sql[0][$i] ); $i++ ) {
	    //echo "Field: " . $sql[0][$i] . "<BR>";
	    //echo "Value: " . $sql[1][$i] . "<BR>";
	//}

	// either update or insert the tuple, depending on whether it already exists
	if( $record_id != "NULL" && $record_id != "" ) {
	    // this record already exists; update it
	    $query = "update $tablename set ";
	    for( $i = 0; ! empty( $sql[0][$i + 1] ); $i++ ) {
		$query .= $sql[0][$i];
		$query .= " = " . $sql[1][$i] . ", ";
	    }
	    $query .= $sql[0][$i];
	    $query .= " = " . $sql[1][$i];
	    $query .= " where $tablekey = " . quote_if_string( $record_id );

	    //echo $query . "<BR>";
	    $result = dbi_exec( $conn, $query );
	} else {
	    // this is a new record; insert it
	    $record_id = "";

	    $query = "insert into $tablename ( ";
	    for( $i = 0; ! empty( $sql[0][$i + 1] ); $i++ ) {

		// check to see if this field is the tablekey
		if( $sql[0][$i] == $tablekey ) {
		    $record_id = $sql[1][$i];
		}
		$query .= $sql[0][$i] . ", ";
	    }

	    // check to see if this field is the tablekey
	    if( $sql[0][$i] == $tablekey ) {
		$record_id = $sql[1][$i];
	    }
	    $query .= "". $sql[0][$i] . " ) values ( ";

	    for( $i = 0; ! empty( $sql[0][$i + 1] ); $i++ ) {
		$query .= $sql[1][$i] . ", ";
	    }
	    $query .= $sql[1][$i] . " )";
	    //echo $query . "<BR>";
	    $result = dbi_exec( $conn, $query );
	    if( ! $result ) {
		dbi_error( $conn );
	    } else {
		if( empty( $record_id ) ) {
		    $record_id = dbi_getlastid( $conn, $result, $tablename, $tablekey );
		}
	    }
	}
    }
?>
