<?
/*
 * Phormation 
 *  - A library of PHP code to make development of database-driven
 *    html forms easy and quick
 *
 *  Copyright (C) 2000 Jason D. Hildebrand
 *  PeaceWorks Computer Consulting
 *
 *  jason@peaceworks.ca
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Street #330, Boston, MA 02111-1307, USA.
 */


    include_once( PHORMATIONDIR."/date_fcns.php" );
    include_once( PHORMATIONDIR."/misc_fcns.php" );


    
    function make_text_widget( $name, $value, $fieldname, $errortext, $params )
    {
	$value = trim( $value );
	// get all of the datatype parameters into local variables
	// e.g. type, height, width, length, etc.
	parse_str( $params );

	if( empty( $length ) ) {
	    echo "Program error: Must specify length of field $name!!<BR>";
	    return;
	}
	if( empty( $height) ) {
	    $height = 1;
	}
	if( empty( $width ) ) {
	    $width = $length;
	}
	echo "<TR>";
	if( $required ) {
	    $star = '<font class="requiredstar"> *</font>';
	}
	echo "<TD class=\"widgetlabel\">$name$star</TD>";
	if( $height <= 1 ) {
	    echo '<TD><input type="text" name="' . $varprefix . $fieldname . '"';
	    echo ' value="' . HTMLSpecialChars( $value ) . '" size="' . $width . '" maxlength="' . $length . '"></TD>';
	} else {
	    echo '<TD><textarea name="' . $varprefix . $fieldname . '" rows="' . $height .'" cols="' . $width . '" wrap="' . $wrap . '">';
	    echo HTMLSpecialChars( $value );
	    echo "</textarea></TD>";
	}
	if( $errortext != "" ) {
	    echo "<TD>$errortext</TD>";
	}
	echo "</TR>\n";
    }

    function validate_text_widget( $name, $value, $fieldname, $params, $sql, $errortext )
    {
	// get all of the datatype parameters into local variables
	// e.g. type, height, width, length, etc.
	parse_str( $params );

	if( empty( $length ) ) {
	    echo "Program error: Must specify length of field $name!!<BR>";
	    return;
	}
	if( empty( $height) ) {
	    $height = 1;
	}
	if( empty( $width ) ) {
	    $width = $length;
	}

	// get the field value
	$varname = $varprefix . $fieldname;
	global $$varname;
	$value = stripslashes( $$varname );

	if( $required && $value == "" ) {
	    $errortext = "This field is required!";
	    return( false );
	}

	if( strlen( $value ) > $length ) {
	    $errortext = "This field is too long (it is " . strlen( $value ) . " characters, but the maximum is $length characters)";
	    return( false );
	}

	// put the value into the SQL strings 
	if( $value == "" ) {
	    insertvalue( $fieldname, "NULL", &$sql );
	} else {
	    if( $noescapes ) {
		insertvalue( $fieldname, "'" . $value . "'", &$sql );
	    } else {
		insertvalue( $fieldname, "'" . addslashes( $value ) . "'", &$sql );
	    }
	    if( $soundex_column ) {
		insertvalue( $soundex_column, "'" . soundex( $value ) . "'", &$sql );
	    }
	    if( $metaphone_column ) {
		insertvalue( $metaphone_column, "'" . metaphone( $value ) . "'", &$sql );
	    }
	}
	return( true ) ;
    }

    function make_email_widget( $name, $value, $fieldname, $errortext, $params )
    {
	$value = trim( $value );
	// get all of the datatype parameters into local variables
	// e.g. type, height, width, length, etc.
	parse_str( $params );

	if( empty( $length ) ) {
	    echo "Program error: Must specify length of field $name!!<BR>";
	    return;
	}
	if( empty( $width ) ) {
	    $width = $length;
	}
	echo "<TR>";
	if( $required ) {
	    $star = '<font class="requiredstar"> *</font>';
	}
	echo "<TD class=\"widgetlabel\">$name$star</TD>";
	echo '<TD><input type="text" name="' . $varprefix . $fieldname . '"';
	echo ' value="' . HTMLSpecialChars( $value ) . '" size="' . $width . '" maxlength="' . $length . '"></TD>';
	if( $errortext != "" ) {
	    echo "<TD>$errortext</TD>";
	}
	echo "</TR>\n";
    }

    function validate_email_widget( $name, $value, $fieldname, $params, $sql, $errortext )
    {
	// get all of the datatype parameters into local variables
	// e.g. type, height, width, length, etc.
	parse_str( $params );

	// get the field value
	$varname = $varprefix . $fieldname;
	global $$varname;
	$value = stripslashes( $$varname );

	if( $required && $value == "" ) {
	    $errortext = "This field is required!";
	    return( false );
	}

	if( strlen( $value ) > $length ) {
	    $errortext = "This field is too long (it is " . strlen( $value ) . " characters, but the maximum is $length characters)";
	    return( false );
	}


	if( $dns && !empty( $value ) ) {
	    $pos = strpos( $value, "@" );
	    $host = substr( $value, $pos + 1 );
	    if( ! checkdnsrr( $host, "ANY" ) ) {
		$errortext = "Please enter a valid email address.";
		return( false );
	    }
	} else if( !empty( $value) && ! ereg( "[^@]+@[^\.]+(\.[^\.]+)+", $value ) ) {
	    $errortext = "Please enter a valid email address.";
	    return( false );
	}

	// put the value into the SQL strings 
	if( $value == "" ) {
	    insertvalue( $fieldname, "NULL", &$sql );
	} else {
	    if( $noescapes ) {
		insertvalue( $fieldname, "'" . $value . "'", &$sql );
	    } else {
		insertvalue( $fieldname, "'" . addslashes( $value ) . "'", &$sql );
	    }
	    if( $soundex_column ) {
		insertvalue( $soundex_column, "'" . soundex( $value ) . "'", &$sql );
	    }
	    if( $metaphone_column ) {
		insertvalue( $metaphone_column, "'" . metaphone( $value ) . "'", &$sql );
	    }
	}
	return( true ) ;
    }


    function make_password_widget( $name, $value, $fieldname, $errortext, $params )
    {
	$value = trim( $value );
	// get all of the datatype parameters into local variables
	// e.g. type, height, width, length, etc.
	parse_str( $params );

	if( empty( $length ) ) {
	    echo "Program error: Must specify length of field $name!!<BR>";
	    return;
	}
	if( empty( $height) ) {
	    $height = 1;
	}
	if( empty( $width ) ) {
	    $width = $length;
	}
	echo "<TR>";
	if( $required ) {
	    $star = '<font class="requiredstar"> *</font>';
	}
	echo "<TD class=\"widgetlabel\">$name$star</TD>";

	echo '<TD><input type="password" name="' . $varprefix . $fieldname . '"';
	echo ' value="' . HTMLSpecialChars( $value ) . '" size="' . $width . '" maxlength="' . $length . '"></TD>';

	if( $errortext != "" ) {
	    echo "<TD>$errortext</TD>";
	}
	echo "</TR>\n";
	if( $verify ) {
	    echo "<TR>";
	    if( $required ) {
		$star = '<font class="requiredstar"> *</font>';
	    }
	    echo "<TD class=\"widgetlabel\">$name again$star<BR>(for verification)</TD>";

	    echo '<TD><input type="password" name="' . $varprefix . $fieldname . '_2"';
	    echo ' value="' . HTMLSpecialChars( $value ) . '" size="' . $width . '" maxlength="' . $length . '"></TD>';
	    echo "</TR>\n";
	}
    }

    function validate_password_widget( $name, $value, $fieldname, $params, $sql, $errortext )
    {
	// get all of the datatype parameters into local variables
	// e.g. type, height, width, length, etc.
	parse_str( $params );

	if( empty( $length ) ) {
	    echo "Program error: Must specify length of field $name!!<BR>";
	    return;
	}
	if( empty( $height) ) {
	    $height = 1;
	}
	if( empty( $width ) ) {
	    $width = $length;
	}

	// get the field value
	$varname = $varprefix . $fieldname;
	global $$varname;
	$value = stripslashes( $$varname );

	if( $required && $value == "" ) {
	    $errortext = "This field is required!";
	    return( false );
	}

	if( strlen( $value ) > $length ) {
	    $errortext = "This field is too long (it is " . strlen( $value ) . " characters, but the maximum is $length characters)";
	    return( false );
	}
	
	if( $verify ) {
	    $varname2 = $varname . "_2";
	    global $$varname2;
	    $value2 = $$varname2;
	    if( $value != $value2 ) {
		$errortext = "The passwords do not match, please re-enter them.";
		$value = "";
		return( false );
	    }
	}

	// put the value into the SQL strings 
	if( $value == "" ) {
	    insertvalue( $fieldname, "NULL", &$sql );
	} else {
	    if( $noescapes ) {
		insertvalue( $fieldname, "'" . $value . "'", &$sql );
	    } else {
		insertvalue( $fieldname, "'" . addslashes( $value ) . "'", &$sql );
	    }
	}
	return( true ) ;
    }

    function make_select_widget( $name, $value, $fieldname, $errortext, $params )
    {
	$value = trim( $value );
	// get all of the datatype parameters into local variables
	// e.g. type, height, width, length, etc.
	parse_str( $params );

	echo "<TR>";
	if( $required ) {
	    $star = '<font class="requiredstar"> *</font>';
	}
	echo "<TD class=\"widgetlabel\">$name$star</TD>";
	echo '<TD>';
	if( $selecttype == "horizontal_radio" ) {
	    reset( $map );
	    for( ; ; ) {
		$string = stripslashes( current( $map ) );
		if( $value == key( $map ) ) {
		    echo '<input type="radio" name="' . $varprefix . $fieldname . '" value="' . key($map) . '" CHECKED>' . $string;
		} else {
		    echo '<input type="radio" name="' . $varprefix . $fieldname . '" value="' . key($map) . '">' . $string;
		}
		$rc = next( $map );
		if( ! $rc ) {
		    break;
		}
		echo "&nbsp;";
	    }
	} else if( $selecttype == "vertical_radio" ) {
	    reset( $map );
	    for( ; ; ) {
		$string = stripslashes( current( $map ) );
		if( $value == key( $map ) ) {
		    echo '<input type="radio" name="' . $varprefix . $fieldname . '" value="' . key($map) . '" CHECKED>' . $string . "<BR>";
		} else {
		    echo '<input type="radio" name="' . $varprefix . $fieldname . '" value="' . key($map) . '">' . $string . "<BR>";
		}
		$rc = next( $map );
		if( ! $rc ) {
		    break;
		}
	    }
	} else if( $selecttype == "dropdown" ) {
	    echo '<select name="' . $varprefix . $fieldname . '">';
	    reset( $map );
	    for( ; ; ) {
		$string = stripslashes( current( $map ) );
		if( $value == key($map) ) {
		    echo '<option selected value="' . key($map) . '">' . $string . '</option>';
		} else {
		    echo '<option value="' . key($map) . '">' . $string . '</option>';
		}
		echo "&nbsp;";
		$rc = next( $map );
		if( ! $rc ) {
		    break;
		}
	    }
	    echo '</select>';
	}
	echo "</TD>";

	if( $errortext != "" ) {
	    echo "<TD>$errortext</TD>";
	}
	echo "</TR>\n";
    }

    function validate_select_widget( $name, $value, $fieldname, $params, $sql, $errortext )
    {
	// get all of the datatype parameters into local variables
	// e.g. type, height, width, length, etc.
	parse_str( $params );

	// get the field value
	$varname = $varprefix . $fieldname;
	global $$varname;
	$value = $$varname;

	if( $required && $value == "" ) {
	    $errortext = "This field is required!";
	    return( false );
	}

	// put the value into the SQL strings 
	if( $value == "" ) {
	    insertvalue( $fieldname, "NULL", &$sql );
	} else {
	    // check if the value is an int or a string
	    $n = intval($value);
	    if( "$n" == $value ) {
		// the value is an int
		insertvalue( $fieldname, $value, &$sql );
	    } else {
		// the value is a string
		insertvalue( $fieldname, "'" . $value . "'", &$sql );
	    }
	}
	return( true ) ;
    }

    function make_help_widget( $name, $value, $fieldname, $errortext, $params )
    {
	global $FORMBGCOLOUR;

	$value = trim( $value );
	// get all of the datatype parameters into local variables
	// e.g. type, height, width, length, etc.
	parse_str( $params );

	echo '</table>';
	echo stripslashes( $html );
	echo '<table border="0" cellspacing="1" cellpadding="0" bgcolor="'. $FORMBGCOLOUR . '">';
    }

    function validate_help_widget( $name, $value, $fieldname, $params, $sql, $errortext )
    {
	return true;
    }

    function make_readonly_widget( $name, $value, $fieldname, $errortext, $params )
    {
        global $params;

	$value = trim( $value );
	// get all of the datatype parameters into local variables
	// e.g. type, height, width, length, etc.
	parse_str( $params );

        if( !empty( $params[$fieldname]["format"] ) ) {
            $format_function = "format_" . $params[$fieldname]["format"];
            if( function_exists($format_function) ){
                $formatted_data = $format_function( $value );
            } else {
                $formatted_data = $value;
            }
        } else {
            $formatted_data = $value;
        }

	echo "<tr>";
	echo "<TD class=\"widgetlabel\">$name</TD>";
	echo "<td>&nbsp;" . HTMLSpecialChars( $formatted_data ) . "</td></tr>";
	make_hidden_widget( $name, $value, $fieldname, $errortext, $params );
    }

    function validate_readonly_widget( $name, $value, $fieldname, $params, $sql, $errortext )
    {
	// get all of the datatype parameters into local variables
	// e.g. type, height, width, length, etc.
	parse_str( $params );

	$rc = validate_hidden_widget( $name, &$value, $fieldname, $params, &$sql, &$errortext );
	return( $rc );
    }

    function make_hidden_widget( $name, $value, $fieldname, $errortext, $params )
    {
	$value = trim( $value );
	// get all of the datatype parameters into local variables
	// e.g. type, height, width, length, etc.
	parse_str( $params );

	echo '<tr><td><input type="hidden" name="' . $varprefix . $fieldname . '"';
	echo ' value="' . HTMLSpecialChars( $value ) . '"></td></tr>';
    }

    function validate_hidden_widget( $name, $value, $fieldname, $params, $sql, $errortext )
    {
	// get all of the datatype parameters into local variables
	// e.g. type, height, width, length, etc.
	parse_str( $params );

	// get the field value
	$varname = $varprefix . $fieldname;
	global $$varname;
	$value = $$varname;

	// put the value into the SQL strings 
	if( $value == "" ) {
	    insertvalue( $fieldname, "NULL", &$sql );
	} else {
	    if( $noescapes ) {
		insertvalue( $fieldname, "'" . $value . "'", &$sql );
	    } else {
		insertvalue( $fieldname, "'" . addslashes( $value ) . "'", &$sql );
	    }
	}
	return( true ) ;
    }

    function make_date_widget( $name, $value, $fieldname, $errortext, $params )
    {
	global $full_months;

	parse_str( $params );
	if( empty( $yearspan) ) {
	    $yearspan = 5;
	}
	$value = trim( $value );
	if( $value == "" || $value == "NULL" ) {
	    $array["day"] = "";
	    $array["month"] = -1;
	    $array["year"] = -1;
	} else {
	    $array = parse_date( $value );
	}

	if( $required ) {
	    $star = '<font class="requiredstar"> *</font>';
	}
	?>
	<TR>
	<TD class="widgetlabel"><? echo $name . $star ?></TD>
	<TD>
	    <? //echo $array["day"] . " " . $array["month"] . " " .  $array["year"] ?>  
	<select name="<? echo $varprefix . $fieldname . "_month" ?>">
	    <?
		if( $array["month"] == -1 ) {
			echo '<option selected value="NULL">--------</option>';
		} else {
			echo '<option value="NULL">--------</option>';
		}
		for( $i = 1; $i <= 12; $i++ ) {
		    if( $i == $array["month"] ) {
			echo '<option selected value="' . $i . '">' . $full_months[$i] . '</option>';
		    } else {
			echo '<option value="' . $i . '">' . $full_months[$i] . '</option>';
		    }
		}
	    ?>
	</select>
	<input type="text" name="<? echo $varprefix . $fieldname . "_day"?>" value="<? echo $array["day"] ?>" size="2" maxlength="2">
	<? 
	if( $allyears ) {
	  if( $array["year"] == -1 ) {
	    $array["year"] = "";
	  }
	  echo '<input type="text" name="' . $varprefix . $fieldname . '_year"';
	  echo ' value="' . $array["year"] . '" size="4" maxlength="4">';
	} else {
	  echo '<select name="' . $varprefix . $fieldname . '_year">';
	  $year = (int) date( "Y", time() );
	  if ($birthdate == 1) {
	    $yearspan=90;
	    $year -= 90;
	  }  else {
	    $year -= floor( $yearspan / 2 );
	  }
	  if( $array["year"] == -1 ) {
	    echo '<option selected value="NULL">----</option>';
	  } else {
	    echo '<option value="NULL">----</option>';
	  }
	  for( $i = 0; $i < $yearspan; $i++ ) {
	    if( $year == $array["year"] ) {
	      // make the proper year selected
	      echo '<option selected value="' . $year . '" >' . $year . '</option>';
	    } else {
	      echo '<option value="' . $year . '" >' . $year . '</option>';
	    }
	    
	    $year += 1;
	  }
	  echo '</select>';
	}
	?>
	</TD>
	<?
	if( $errortext != "" ) {
	    echo "<TD>$errortext</TD>";
	}
	echo "</TR>";
    }

    function validate_date_widget( $name, $value, $fieldname, $params, $sql, $errortext )
    {
	// get all of the datatype parameters into local variables
	// e.g. type, height, width, length, etc.
	parse_str( $params );

	// get the field value
	$varname = $varprefix . $fieldname . "_year";
	global $$varname;
	$year = $$varname;
	$varname = $varprefix . $fieldname . "_month";
	global $$varname;
	$month = $$varname;
	$varname = $varprefix . $fieldname . "_day";
	global $$varname;
	$day = $$varname;

	$day = trim( $day );
	//echo "Year = $year<BR>";
	//echo "Month = $month<BR>";
	//echo "Day = $day<BR>";

	if( $year == "NULL" && $month == "NULL" && ($day == "" || $day =="00")) {
	    $value = "NULL";
	} else if ( $year == "" && $month == "NULL" && $day == "" ) {
	   $value = "NULL";
	} else if( $year == "" || $year == "NULL" || $month == "NULL" || $day == "" ) {
	    $value = "NULL";
	    $errortext = "The year/month/day components must all be set or all left blank.";
	    return( false );
	} else {
	    $value = $year . "-" . $month . "-" . $day;
	    $gooddate = checkdate( $month, $day, $year );
	    if( ! $gooddate ) {
		$errortext = "$value is not a valid date.";
		//$value = "NULL";
		return( false );
	    }
	}

	if( $required && $value == "NULL" ) {
	    $errortext = "This field is required!";
	    return( false );
	}

	// put the value into the SQL strings 
	if( $value == "NULL" ) {
	    insertvalue( $fieldname, "NULL", &$sql );
	} else {
	    insertvalue( $fieldname, "'$value'", &$sql );
	}
	return( true ) ;
    }



    // this "widget" assumes that the time is stored in a text
    // field in the database and looks like "10:30 p.m."
    function make_timetext_widget( $name, $value, $fieldname, $errortext, $params )
    {
	trim( $value );
	if( $value == "" || $value == "NULL" ) {
	    $time = "";
	    $mode = "";
	} else {
	    $time = trim( substr( $value, 0, 5 ) );
	    $mode = trim( substr( $value, 5, 5 ) );
	}
	if( $required ) {
	    $star = '<font class="requiredstar"> *</font>';
	}
	echo "<TR>";
	echo "<TD class=\"widgetlabel\">$name$star</TD>";
	echo '<TD><input type="text" name="' . $varprefix . $fieldname . '"';
	echo 'value="' . $time . '" size="5" maxlength="5">';
	echo '<select name="' . $varprefix . $fieldname . "_mode" . '">';
	if( $mode == "" ) {
	    echo '<option selected value="NULL">----</option>';
	} else {
	    echo '<option value="NULL">----</option>';
	}
	if( $mode == "a.m." ) {
	    echo '<option selected value="am">a.m.</option>';
	} else {
	    echo '<option value="am">a.m.</option>';
	}
	if( $mode == "p.m." ) {
	    echo '<option selected value="pm">p.m.</option>';
	} else {
	    echo '<option value="pm">p.m.</option>';
	}
	echo "</select></TD>";
	if( $errortext != "" ) {
	    echo "<TD>$errortext</TD>";
	}
	echo "</TR>\n";
    }

    function validate_timetext_widget( $name, $value, $fieldname, $params, $sql, $errortext )
    {
	// get all of the datatype parameters into local variables
	// e.g. type, height, width, length, etc.
	parse_str( $params );

	// get the field value
	$varname = $varprefix . $fieldname;
	global $$varname;
	$time = $$varname;
	$varname = $varprefix . $fieldname . "_mode";
	global $$varname;
	$mode = $$varname;

	$time = trim( $time );

	if( $mode == "NULL" && $time == "" ) {
	    $value = "NULL";
	} else if( $mode == "NULL" || $time == "" ) {
	    $errortext = "The time/mode components must all be set or all left blank.";
	    return( false );
	} else {
	    $value = $time . " ";
	    if( $mode == "am" ) {
		$value .= "a.m.";
	    } else {
		$value .= "p.m.";
	    }
	}

	// TODO: make sure the time is valid

	if( $required && $value == "NULL" ) {
	    $errortext = "This field is required!";
	    return( false );
	}

	// put the value into the SQL strings 
	if( $value == "NULL" ) {
	    insertvalue( $fieldname, "NULL", &$sql );
	} else {
	    insertvalue( $fieldname, "'$value'", &$sql );
	}
	return( true ) ;
    }

    function make_fkey_widget( $name, $value, $fieldname, $errortext, $params )
    {
	global $conn;

	// get all of the datatype parameters into local variables
	// e.g. type, height, width, length, etc.
	parse_str( $params );

	if( $required ) {
	    $star = '<font class="requiredstar"> *</font>';
	}
	echo "<TR>";
	echo "<TD class=\"widgetlabel\">$name$star</TD>";
	echo "<TD>";

	$query = "select $pkey, $desc from $table";
	$result = $conn->query($query);
	if (DB::isError($result)) {
	  echo "Error: $query <br>";
	  echo $result->getMessage()."<BR>";
	  return;
	}
	echo '<select name="' . $varprefix . $fieldname . '">';
	$numrows = $result->numRows();
	for( $i = 0; $i < $numrows; $i++ ) {
	    $array = $result->fetchRow( DB_FETCHMODE_ORDERED, $i );
	    if( $array[$pkey] == $value ) {
		echo '<option selected value="' . $array[$pkey] . '">' . $array[$desc] . '</option>';
	    } else {
		echo '<option value="' . $array[$pkey] . '">' . $array[$desc] . '</option>';
	    }
	}
	echo '</select></td>';
	if( $errortext != "" ) {
	    echo "<TD>$errortext</TD>";
	}
	echo '</tr>';
    }

    function validate_fkey_widget( $name, $value, $fieldname, $params, $sql, $errortext )
    {
	// get all of the datatype parameters into local variables
	// e.g. type, height, width, length, etc.
	parse_str( $params );

	// get the field value
	$varname = $varprefix . $fieldname;
	global $$varname;
	$value = $$varname;

	// put the value into the SQL strings 
	insertvalue( $fieldname, $value, &$sql );
	return( true ) ;
    }

    function make_boolean_widget( $name, $value, $fieldname, $errortext, $params )
    {
	// get all of the datatype parameters into local variables
	// e.g. type, height, width, length, etc.
	parse_str( $params );

	echo "<TR>";
	if( $required ) {
	    $star = '<font class="requiredstar"> *</font>';
	}
	echo "<TD class=\"widgetlabel\">$name$star</TD>";
	if( $value == "1" ) {
	    $checked = "CHECKED";
	} else {
	    $checked = "";
	}
	echo '<TD><input type="checkbox" name="' . $varprefix . $fieldname . '" value="1"' . $checked . '></TD>';
	if( $errortext != "" ) {
	    echo "<TD>$errortext</TD>";
	}
	echo "</TR>\n";
    }

    function validate_boolean_widget( $name, $value, $fieldname, $params, $sql, $errortext )
    {
	// get all of the datatype parameters into local variables
	// e.g. type, height, width, length, etc.
	parse_str( $params );

	// get the field value
	$varname = $varprefix . $fieldname;
	global $$varname;
	$value = $$varname;

	// put the value into the SQL strings 
	if( $value == "1" ) {
	    insertvalue( $fieldname, "1", &$sql );
	} else {
	    insertvalue( $fieldname, "0", &$sql );
	}
	return( true ) ;
    }

    function make_creditexpiry_widget( $name, $value, $fieldname, $errortext, $params )
    {
	$value = trim( $value );

	// get all of the datatype parameters into local variables
	// e.g. type, height, width, length, etc.
	parse_str( $params );

	$month = substr( $value, 0, 2 );
	$year = substr( $value, 3, 2 );

	echo "<TR>";
	if( $required ) {
	    $star = '<font class="requiredstar"> *</font>';
	}
	echo "<TD class=\"widgetlabel\">$name$star";
	echo '<BR><font size="-1">(in MM/YY format,<BR> as it appears on your card)</font></TD>';
	echo '<TD>';
	echo '<input type="text" name="' . $varprefix . $fieldname . '_month"';
	echo ' value="' . $month . '" size="2" maxlength="2">';
	echo ' / ';
	echo '<input type="text" name="' . $varprefix . $fieldname . '_year"';
	echo ' value="' . $year . '" size="2" maxlength="2">';
	echo '</TD>';
	if( $errortext != "" ) {
	    echo "<TD>$errortext</TD>";
	}
	echo "</TR>\n";
    }

    function validate_creditexpiry_widget( $name, $value, $fieldname, $params, $sql, $errortext )
    {
	// get all of the datatype parameters into local variables
	// e.g. type, height, width, length, etc.
	parse_str( $params );

	// get the field value
	$varname = $varprefix . $fieldname . "_month";
	global $$varname;
	$month = $$varname;

	$varname = $varprefix . $fieldname . "_year";
	global $$varname;
	$year = $$varname;

	if( $required && ( empty( $month ) || empty( $year ) ) ) {
	    $errortext = "Please fill in the month and the year!";
	    return( false );
	}
	
	$value = "$month/$year";

	// put the value into the SQL strings 
	if( $value == "" ) {
	    insertvalue( $fieldname, "NULL", &$sql );
	} else {
	    insertvalue( $fieldname, "'" . $value . "'", &$sql );
	}
	return( true ) ;
    }


    //BEGIN phone_widget

    function make_phone_widget( $name, $value, $dbfield, $errortext, $params )
    {
	// the following function takes the parameter string (which is the
	// "type" string passed in to form_main, with some variables added by
	// Phormation), and creates local a variable containing the parameter 
	// for each key/value pair in the string (it's a PHP function)
	parse_str( $params );

	// if the value is empty, initialize our variables to empty
	if( $value == "" ) {
	    $areacode = "";
	    $prefix = "";
	    $number = "";
	} else {
	    // otherwise chunk up the string into the three parts
	    // the string may contain spaces (see the validate function)
	    // so after we split it up we trim the spaces.
	    $areacode = trim( substr( $value, 0 , 3 ) );
	    $prefix = trim( substr( $value, 3 , 3 ) );
	    $number = trim( substr( $value, 6 , 4 ) );
	}

	if( $required ) {
	    $star = '<font class="requiredstar"> *</font>';
	}

	// output the widget label
	?>
	<TR>
	<TD class="widgetlabel"><? echo $name . $star ?></TD>
	<?

	echo "<TD>";

	// make the area code field.  The Phormation convention is that input
	// names are made up of the variables $varprefix and $dbfield, followed
	// by some suffix if the widget uses multiple input fields.  
	// $varprefix is part of the "params" string passed to the widget, and
	// must be used so that the widget will work properly in multiforms.
	// (so that the input names don't collide)
	echo '(';
	echo '<input type="text" size="3" maxlength="3" name="' . $varprefix . $dbfield . '_areacode" ';
	echo 'value="' . $areacode . '">';

	echo ')&nbsp;-&nbsp;';

	// likewise create the prefix field
	echo '<input type="text" size="3" maxlength="3" name="' . $varprefix . $dbfield . '_prefix" ';
	echo 'value="' . $prefix . '">';

	echo '&nbsp;-&nbsp;';

	// and the number field
	echo '<input type="text" size="4" maxlength="4" name="' . $varprefix . $dbfield . '_number" ';
	echo 'value="' . $number . '">';

	echo "</TD>";

	// display an error if there is one
	if( $errortext != "" ) {
	    echo "<TD>$errortext</TD>";
	}
	echo "</TR>";
    }

    function validate_phone_widget( $name, $value, $dbfield, $params, $sql, $errortext )
    {
	// get all of the datatype parameters into local variables
	// e.g. type, height, width, length, etc.
	parse_str( $params );

	// construct the names of the input fields, bring
	// the variables into the local scope
	$varname = $varprefix . $dbfield . "_areacode";
	global $$varname;
	$areacode = $$varname;
	$varname = $varprefix . $dbfield . "_prefix";
	global $$varname;
	$prefix = $$varname;
	$varname = $varprefix . $dbfield . "_number";
	global $$varname;
	$number = $$varname;

	// now do some checking on the input.  Make sure no component is 
	// empty or has less than the required number of digits

	if( $areacode == "" && $prefix == "" && $number == "" ) {
	    $value = "";
	} else if( $areacode == "" || strspn( $areacode, "0123456789" ) < 3 ) {
	    // if areacode is missing or too short, prompt the user to enter it
	    $value = "   " . str_pad( $prefix, 3 ) . str_pad( $number, 4 );
	    $errortext = "Please enter the area code.";
	    return( false );
	} else if( $prefix == "" || strspn( $prefix, "0123456789" ) < 3 ) {
	    // if prefix or number is missing, prompt the user
	    $value = $areacode . "   " . str_pad( $number, 4 );
	    $errortext = "Please enter your full phone number.";
	    return( false );
	} else if( $number == "" || strspn( $number, "0123456789" ) < 4 ) {
	    // if prefix or number is missing, prompt the user
	    $value = $areacode . str_pad( $prefix, 3 ) . "    ";
	    $errortext = "Please enter your full phone number.";
	    return( false );
	} else {
	    $value = $areacode . $prefix . $number;
	}

	// if the number was completely empty but the field is required,
	// then return an error
	if( $required && $value == "" ) {
	    $errortext = "This field is required!";
	    return( false );
	}

	// if we're here then we validated ok, so store the phone number 
	// 
	if( $value == "" ) {
	    insertvalue( $dbfield, "NULL", &$sql );
	} else {
	    insertvalue( $dbfield, "'$value'", &$sql );
	}
	return( true ) ;
    }

    //END phone_widget


    function make_file_widget( $name, $value, $fieldname, $errortext, $params )
    {
	// get all of the datatype parameters into local variables
	// e.g. type, height, width, length, etc.
	parse_str( $params );

	$filefield = strtok( $fieldname, "," );	// the filename is stored in this field
	$originalname = strtok( "," );		// the original (as uploaded) filename is stored here

	//echo "<TD>" . $filefield . "</TD>";
	//echo "<TD>" . $value[$filefield] . "</TD>";
	$value[$filefield] = trim( $value[$filefield] );
	$value[$originalname] = trim( $value[$originalname] );

	// create a global variable which holds the current filename (and full
	// path).  This file might be a temp file or already be in the target directory
	$currentfile = $varprefix . $filefield . "_current";
	global $$currentfile;

	// the stored file, if set, is the full path of the file that was
	// previously stored.  We have to remember the filename so that we can
	// delete it if it is replaced by an uploaded file
	$storedfile = $varprefix . $filefield . "_stored";
	global $$storedfile;
	global $record_id;

	if( $$currentfile == "" && $value[$filefield] != "" ) {
	    $$currentfile = $targetdir . "/" . $value[$filefield];
	}

	if( empty( $noclear ) ) {
	    ?>
	    <script language="JavaScript">
	    <!--
		function clear<? echo $filefield ?>()
		{
		    document.mainform.<? echo $varprefix . $filefield . "_clear" ?>.value = 'clear';
		    document.mainform.refresh.value = 'refresh';
		    document.mainform.submit();
		    //return false;
		}
	    // -->
	    </script>
	    <?
	}

	echo "<TR>";
	if( $required ) {
	    $star = '<font class="requiredstar"> *</font>';
	}
	echo "<TD class=\"widgetlabel\">$name$star";
	//echo "Currentfile = " . $$currentfile;
	echo "</TD>";
	echo '<td>';
	echo '<table><tr>';
	if( $imagemode && ( dirname( $$currentfile ) == $targetdir ) ) {
	    // image name must be encoded, since it may contain spaces or
	    // other nasties which browsers don't like
	    $imgref = $serverdir . "/" . rawurlencode( basename( $$currentfile ));
	    echo '<td><img height="60" src="' . $imgref . '"></td>';
	} else if( $imagemode && ! empty( $value[$originalname] ) ) {
	    echo '<td>' . $value[$originalname] . '<BR> has been uploaded.</TD>';
	}
	echo '<td>';
	if( $showfilename ) {
	    echo 'Current File: ';
	    if( $value[$originalname] == "" ) {
		echo 'none';
	    } else {
		echo $value[$originalname];
	    }
	}
	echo '<BR>';
	echo '<input type="file" name="' .$varprefix . $filefield . '">';
	echo '<input type="hidden" name="' .$varprefix . $filefield . '_current" value="' . $$currentfile . '">';
	echo '<input type="hidden" name="' .$varprefix . $filefield . '_oldfilename" value="' . $value[$filefield] . '">';
	echo '<input type="hidden" name="' .$varprefix . $filefield . '_oldoriginalname" value="' . $value[$originalname] . '">';
	echo '<input type="hidden" name="' .$varprefix . $filefield . '_stored" value="' . $$storedfile . '">';
	if( empty( $noclear ) ) {
	    echo '<input type="hidden" name="' .$varprefix . $filefield . '_clear" value="">';
	    echo '&nbsp;&nbsp;<input type = "button" name="action" value = "Clear" onClick="clear' . $filefield . '()" >';
	}
	echo '</TD>';
	echo "</tr></table>";
	echo "</td>";
	if( $errortext != "" ) {
	    echo "<TD>$errortext</TD>";
	}
	echo "</tr>";
    }

    function validate_file_widget( $name, $value, $fieldname, $params, $sql, $errortext )
    {
	global $HTTP_POST_FILES;

	parse_str( $params );

	$filefield = strtok( $fieldname, "," );	// the filename is stored in this field
	$originalname = strtok( "," );		// the original (as uploaded) filename is stored here

	// get the field value
	$varname = $varprefix . $filefield;
	global $$varname;
	$tmpfilename = $$varname;
	$varname = $varprefix . $filefield . "_name";
	global $$varname;
	$filename = basename( $$varname );
	$currentfile = $varprefix . $filefield . "_current";
	$storedfile = $varprefix . $filefield . "_stored";
	global $$currentfile, $$storedfile;
	$varname = $varprefix . $filefield . "_oldoriginalname";
	global $$varname;
	$oldoriginalname = $$varname;
	$varname = $varprefix . $filefield . "_oldfilename";
	global $$varname;
	$oldfilename = $$varname;
	$varname = $varprefix . $filefield . "_clear";
	global $$varname;
	$clear = $$varname;
	$varname = $varprefix . $filefield . "_size";
	global $$varname;
	$filesize = $$varname;

	$value = array();
	
	if( !empty( $max_file_size) && $filesize > $max_file_size ) {
	    $errortext = "File too large!<BR>File cannot be larger than " . floor($max_file_size / 1024) . "k.";
	    $tmpfilename = "none";
	    return( false );
	}

	if( $clear == "clear" ) {
	    // if the current file is a tmp file...
	    if( $$currentfile != "" && dirname( $$currentfile ) != $targetdir ) {
		// then delete it
		if( is_file_in_tmp( $$currentfile ) ) {
		    unlink( $$currentfile );
		}
	    } else {
		// otherwise remember to delete the stored file
		$$storedfile = $$currentfile;
	    }
	    $$currentfile = "";
	    $value[$filefield] = "";
	    $value[$originalname] = "";
	    return( false );
	}
	if( $tmpfilename != "none" && $tmpfilename != "" ) {
	    $succ = @rename( $tmpfilename, $tmpfilename . ".bak" );
	    if( ! $succ ) {
		//echo "Error renaming uploaded file $tmpfilename to $tmpfilename.bak";
	    }
	    //echo "currentfile " . $$currentfile . "<BR>";
	    //echo "dirname " . dirname( $$currentfile ) . "<BR>";
	    //echo "targetdir " . $targetdir . "<BR>";

	    // here we delete the previous current file, if it's not in the target directory
	    if( $$currentfile != "" && dirname( $$currentfile ) != $targetdir ) {
		unlink( $$currentfile );
	    } else {
		$$storedfile = $$currentfile;
	    }

	    $$currentfile = $tmpfilename . ".bak";

	    // here we call the filter, which does any processing it needs
	    // to on the current file, and also returns the target filename 
	    // for this file
	    if( function_exists( $process_hook ) ) {
		$value[$filefield] = $process_hook( $processparm, $tmpfilename . ".bak", $filename, $targetdir );
	    } else {
		$value[$filefield] = $filename;
	    }
	    $value[$originalname] = $filename;

	} else {
	    $value[$filefield] = $oldfilename;
	    $value[$originalname] = $oldoriginalname;
	}
    
	//$errortext = $tmpfilename;
	if( $required && ( $value[$filefield] == "none" || $value[$filefield] == "" ) ) {
	    $errortext = "Please select a file";
	    return( false );
	}

	// put the value into the SQL strings 
	if( $value != "none" ) {
	    if( $noescapes ) {
		insertvalue( $filefield, "'" . $value[$filefield] . "'", &$sql );
		insertvalue( $originalname, "'" . $value[$originalname] . "'", &$sql );
	    } else {
		insertvalue( $filefield, "'" . addslashes( $value[$filefield] ) . "'", &$sql );
		insertvalue( $originalname, "'" . addslashes( $value[$originalname] ) . "'", &$sql );
	    }
	}
	return( true ) ;
    }

    function commit_file_widget( $name, $value, $fieldname, $params, $record_id )
    {
	parse_str( $params );

	$filefield = strtok( $fieldname, "," );	// the filename is stored in this field
	$originalname = strtok( "," );		// the original (as uploaded) filename is stored here

	$currentfile = $varprefix . $filefield . "_current";
	$storedfile = $varprefix . $filefield . "_stored";
	global $$currentfile, $$storedfile;

	//echo "In COMMIT:<BR>";
	//echo "filename = " . $value[$filefield] . "<BR>";
	//echo "currentfile = " . $$currentfile . "<BR>";
	//echo "storedfile = " . $$storedfile . "<BR>";
	
	// delete the storedfile (if any) first, since if the new file has the
	// same name we must do this before copying the new file to the same
	// location (otherwise we copy the new file and then delete it)
	if( ! empty( $$storedfile ) ) {
	    $file = $targetdir . "/" . basename( $$storedfile );
	    //echo "Deleting " . $file . "<BR>";
	    unlink( $file );
	}
	if( $$currentfile != "" && dirname( $$currentfile ) != $targetdir ) {
	    if( is_file_in_tmp( $$currentfile ) ) {

		$rc = copy( $$currentfile, $targetdir . "/" .  $value[$filefield] );
		unlink( $$currentfile );
	    }
	}
    }

    function abort_file_widget( $name, $value, $fieldname, $params, $record_id )
    {
	parse_str( $params );

	$filefield = strtok( $fieldname, "," );	// the filename is stored in this field
	$originalname = strtok( "," );		// the original (as uploaded) filename is stored here

	$currentfile = $varprefix . $filefield . "_current";
	$storedfile = $varprefix . $filefield . "_stored";
	global $$currentfile, $$storedfile;

	//echo "In ABORT:<BR>";
	//echo "filename = " . $value[$filefield] . "<BR>";
	//echo "currentfile = " . $$currentfile . "<BR>";
	//echo "storedfile = " . $$storedfile . "<BR>";
	
	if( $$currentfile != "" && dirname( $$currentfile ) != $targetdir ) {
	    if( is_file_in_tmp( $$currentfile ) ) {
		unlink( $$currentfile );
	    }
	}
    }

    function is_file_in_tmp( $filename ) 
    {
	// first figure out the tmp dir used by PHP to store uploaded files
	$tmpdir = get_cfg_var( "upload_tmp_dir" );
	if( empty( $tmpdir ) ) {
	    $tmpdir = getenv( "TMPDIR" );
	} 
	if( empty( $tmpdir ) ) {
	    $tmpdir = "/tmp";
	}
	
	// trim any trailing slash
	if( $tmpdir[strlen($tmpdir) - 1] == '/' ) {
	    $tmpdir = substr( $tmpdir, 0, strlen($tmpdir) - 1 );
	}

	$tmpfile = $tmpdir . "/" . basename( $filename );
	return( $tmpfile == $filename );
    }



    function make_integer_widget( $name, $value, $fieldname, $errortext, $params )
    {
	$value = trim( $value );
	// get all of the datatype parameters into local variables
	// e.g. type, height, width, length, etc.
	parse_str( $params );

	if( empty( $length ) ) {
	    echo "Program error: Must specify length of field $name!!<BR>";
	    return;
	}
	if( empty( $width ) ) {
	    $width = $length;
	}
	echo "<TR>";
	if( $required ) {
	    $star = '<font class="requiredstar"> *</font>';
	}
	echo "<TD class=\"widgetlabel\">$name$star</TD>";
	echo '<TD><input type="text" name="' . $varprefix . $fieldname . '"';
	echo ' value="' . HTMLSpecialChars( $value ) . 
	  '" size="' . $width . '" maxlength="' . $length . '"></TD>';
	if( $errortext != "" ) {
	    echo "<TD>$errortext</TD>";
	}
	echo "</TR>\n";
    }

    function validate_integer_widget( $name, $value, $fieldname, $params, $sql, $errortext )
    {
	// get all of the datatype parameters into local variables
	// e.g. type, height, width, length, etc.
	parse_str( $params );

	// get the field value
	$varname = $varprefix . $fieldname;
	global $$varname;
	$value = stripslashes( $$varname );

	if( $required && $value == "" ) {
	    $errortext = "This field is required!";
	    return( false );
	}

	if( strlen( $value ) > $length ) {
	    $errortext = "This field is too long (it is " . strlen( $value ) . 
	       " characters, but the maximum is $length characters)";
	    return( false );
	}

	if( !empty( $value) && !is_numeric( $value ) ) {
	    $errortext = "Please enter a numeric value with no decimals ($value)";
	    return( false );
	}

	// put the value into the SQL strings 
	if( $value == "" ) {
	    insertvalue( $fieldname, "NULL", &$sql );
	} else {
	    if( $noescapes ) {
		insertvalue( $fieldname, "'" . $value . "'", &$sql );
	    } else {
		insertvalue( $fieldname, "'" . addslashes( $value ) . "'", &$sql );
	    }
	    if( $soundex_column ) {
		insertvalue( $soundex_column, "'" . soundex( $value ) . "'", &$sql );
	    }
	    if( $metaphone_column ) {
		insertvalue( $metaphone_column, "'" . metaphone( $value ) . "'", &$sql );
	    }
	}
	return( true ) ;
    }


?>
