<?
/*
 * Empris
 *
 *  Copyright (C) 2001 Adam G. Thomas
 *  Oxfam Community Aid Abroad Australia
 *
 *  adamt@caa.org.au
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the The Artistic License as published at
 *  http://www.opensource.org/licenses/artistic-license.html
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the Artistic License
 *  along with this program; if not, visit the above URL.
 */

include_once( "global.php" );
include_once( "dbconnect.php" );
include_once( PHORMATIONDIR."/displaytable.php" );
include_once( "fieldInfo.pinc" );
require_once( "adminOnly.php" );

if (isset($desLang) || isset($desCntry) || isset($desPosCode)) {
  user_setprevsearchparams($desLang, $desCntry, $desPosCode);
}

// get a list of all the languages that are currently in the DB

$sql = "select distinct language from languages";
$res = $conn->query($sql);
if (DB::isError($res)) {
  echo "$sql <br>";
  die ($res->getMessage());
} else {
  while ($row = $res->fetchRow()) {
    $languages[] = $row[0];
  }
}

// get a list of all the countries that are currently in the DB

$sql = "select distinct country from work_exp";
$res = $conn->query($sql);
if (DB::isError($res)) {
  echo "$sql <br>";
  die ($result->getMessage());
} else {
  while ($row = $res->fetchRow()) {
    $countries[] = $row[0];
  }
}

// if desLang is set create a temporary table containing all
// applicants with the desired language. Otherwise create a temporary
// table with all applicants to be used for subsequent joins.

$i =0;
$curTmpTbl = "tmp".$i;

if (isset($desLang) && ($desLang != 'ANY')) {
  if ($DB == "mysql")  $sql= "create temporary table ".$curTmpTbl." select r.regid,r.famname,r.firstname,r.position_code1,r.position_code2,r.position_code3, r.status,l.language from register as r natural left join languages as l where l.language like '$desLang'";
  else  $sql= "create temporary table ".$curTmpTbl." as select r.regid,r.famname,r.firstname,r.position_code1,r.position_code2,r.position_code3, r.status,l.language from register as r natural join languages as l where l.language like '$desLang'";
} else {
  if ($DB == "mysql")  $sql= "create temporary table ".$curTmpTbl." select r.regid,r.famname,r.firstname,r.position_code1,r.position_code2,r.position_code3,r.status from register as r";
  else $sql= "create temporary table ".$curTmpTbl." as select r.regid,r.famname,r.firstname,r.position_code1,r.position_code2,r.position_code3,r.status from register as r";
}
$res = $conn->query($sql);
if (DB::isError($res)) {
  echo "$sql <BR>";
  die ($res->getMessage());
} 

// Now mix in Position code

if (isset($desPosCode) && ($desPosCode != 'ANY') && ($desPosCode != 'ALL')) {
  $prevTmpTbl = "tmp".$i;
  $i++;
  $curTmpTbl = "tmp".$i;
  if ($DB == "mysql")  $sql= "create temporary table ".$curTmpTbl." select * from ".$prevTmpTbl." where position_code1 = '".$desPosCode."' OR position_code2 = '".$desPosCode."' OR position_code3 = '".$desPosCode."' ";
  else  $sql= "create temporary table ".$curTmpTbl." as select * from ".$prevTmpTbl." where position_code1 = '".$desPosCode."' OR position_code2 = '".$desPosCode."' OR position_code3 = '".$desPosCode."' ";
  
  $res = $conn->query($sql);
  if (DB::isError($res)) {
    echo "$sql <BR>";
    die ($res->getMessage());
  } 
}

// Last join: if desCntry is set, construct a query that will select
// all applicants with the desired country exp joined with previous
// tmp table. Otherwise construct a query that will spit out the
// previous temp table.

// Don't execute the query here. Let phormation handle it

if (isset($desCntry) && ($desCntry != 'ANY')) {
  $prevTmpTbl = $curTmpTbl;
  $i++;
  $curTmpTbl = "tmp".$i;
  //  $sql= "create temporary table ".$curTmpTbl." select t.*, we.country from ".$prevTmpTbl." as t natural left join work_exp as we where (we.country like '".$desCntry."')";
  $sql= "select t.*, we.country from ".$prevTmpTbl." as t natural join work_exp as we where (we.country like '".$desCntry."')";
} else {
  $sql = "select * from ".$curTmpTbl;
}


$params["pagelength"] = 50;
$params["query"] = $sql;

    //"select r.regid,r.firstname,r.famname, r.status, r.employed_as, r.position_code1,l.language from register as r NATURAL LEFT JOIN languages as l";
// natural join work_exp at we;
$params["defaultsort"] = "famname";
$params["newlink"] = "editApp.php";
$params["editlink"] = "editApp.php";
$params["delquery"] = "delete from register where regid = ";
$params["predelete_hook"] = "my_predelete_fcn";
$params["key"] = "regid";
$params["extraLink"][] = array("link" => "viewSkills.php",
			       "icon" => "training.gif",
			       "alt"  => "View/Edit Training and Skills");

$params["extraLink"][] = array("link" => "viewField.php",
			       "icon" => "ref-icon1.gif",
			       "alt"  => "View/Edit References");

$params["extraLink"][] = array("link" => "viewRS.php",
			       "icon" => "rs.gif",
			       "alt"  => "View/Edit Runsheet");
$params["deleteLink"] = "default";			       

$fields[] = "firstname";  $names[] = "First Name(s)";
$fields[] = "famname";   $names[] = "Last Name";
$fields[] = "status";   $names[] = "Status";
$fields[] = "position_code1";    $names[] = "Position Code";
if (isset($desLang) && ($desLang != 'ANY')) {
  $fields[] = "language";    $names[] = "Language";
}
if (isset($desCntry) && ($desCntry != 'ANY')) {
  $fields[] = "country";    $names[] = "Country Exp.";
}

function my_predelete_fcn( $record_id ) 
{
   // this function will remove any records in foreign tables:
   user_deleteregid($record_id);
}

function printHeaders() {
  require("pageHead.php");
}


function html_before_table() {

  global $empris, $emplist,$catList,$nameList,$languages,
    $countries, $desCntry, $desLang, $user_name, $desPosCode;
  require("htmlHead.php");
  require("tableHead.php");
  require("nav_bar.php");
  require("tableMid.php");
  
  
  echo " 
  Search for applications:
  <FORM method=\"POST\" action=\"searchApps.php\">
<TABLE>
<TR><TD><b>Language</b></TD><TD ALIGN=\"center\"><b>Country Exp.</b></TD></TR>
<TR><TD>
  <select name=\"desLang\">
  <option value=\"ANY\">any</option>
";
  reset($languages);
  foreach ($languages as $key=> $lang) {
    echo "<option ";
  if ($desLang == $lang) echo " SELECTED ";
  echo " value=\"".$lang."\"> ".
    $lang."</option>\n";
  }
echo "
  </select>
</TD>
<TD>
  <select name=\"desCntry\">
  <option value=\"ANY\">any</option>
";
  reset($countries);
  foreach ($countries as $key=> $cntry) {
    echo "<option";
  if ($desCntry == $cntry) echo " SELECTED ";
  echo " value=\"".$cntry."\"> ".$cntry."</option>\n";
  }

echo "
  </select>
  </TD></TR>
  <TR><TD COLSPAN=2><b>Category: </b>
  <select name=\"desPosCode\">
  <option value=\"ALL\">All Categories</option>
";

  $i=0;
  foreach ($empris->jobCat["code"] as $key=> $val) {
    echo "<option ";
    if ($desPosCode == $val) echo " SELECTED ";
    echo " value=\"".$val."\"> ".
      $empris->jobCat["name"][$i]."</option>\n";
    $i++;
    
  }
  echo "
  </select></TD>
  </TR>
  </TABLE>
  <INPUT TYPE=\"SUBMIT\">
  </FORM>
  ";


}



table_index( $fields, $names, $params );
$conn->disconnect();
require("tableEnd.php");
require("htmlFooter.php");

?>
